#Import Modules
import os, pygame
from pygame.locals import *

from helper import *

class cursorIcon(pygame.sprite.Sprite):
    """cursor icon"""
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image, self.rect = load_image('axeIcon.png', -1)
        self.origImage = self.image
        self.rotate = 0 # 0 to 360
        self.spinRight = 0

    def move(self, xy):
        self.rect.topleft = xy

    def flipSpin(self):
        self.origImage = pygame.transform.flip(self.origImage,1,0)
        self.spinRight = 1
        self.rotate = 0

    def update(self):
        center = self.rect.center
        self.image = pygame.transform.rotate(self.origImage, self.rotate)
        if self.spinRight == 0:
            self.rotate = (self.rotate-3) % 360
        else:
            self.rotate = (self.rotate+3) % 360
        self.rect = self.image.get_rect(center=center)

class Menu():
    def __init__(self):
        self.option = 0
        self.optionMax = 0
        self.cursor = cursorIcon()
        self.cursorOffset = []
        self.bgImage = 0
        self.allsprites = pygame.sprite.RenderPlain((self.cursor))

    def setMenuBG(self, bgImage):
        self.bgImage = bgImage

    def setOptions(self, optionNum):
        self.optionMax = optionNum
        for i in range(0,optionNum+1):
            self.cursorOffset.append((0,0))

    def setCursorOffset(self, cursorOffset, menuOption):
        self.cursorOffset[menuOption] = cursorOffset
        if menuOption == 0:
            self.cursor.move(self.cursorOffset[self.option])

    def display(self, screen):
        screen.blit(self.bgImage, (0, 0))
        self.allsprites.update()
        self.allsprites.draw(screen)
        pygame.display.flip()

    def moveDown(self):
        self.option = (self.option + 1) % self.optionMax
        self.cursor.move(self.cursorOffset[self.option])

    def moveUp(self):
        self.option = (self.option - 1) % self.optionMax
        self.cursor.move(self.cursorOffset[self.option])
