#Import Modules
import os, pygame
from pygame.locals import *

from helper import *

class Player(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image,self.rect = load_image('warriorB1.gif',-1) #this is to get the 32x32 rect
        self.posx = 10.0
        self.posy = 10.0
        self.rect.topleft = self.posx, self.posy
        self.worldx = 0
        self.worldy = 0
        self.worldmaxx = 0
        self.worldmaxy = 0
        self.speed = 5.0
        
        self.frameCount = 0
        self.state = 0 # 0 = stand, 1 = move
        self.direction = 0 # 0 = bottom, 1 = bottomright, 2 = right, 3 = topright
                           # 4 = top, 5 = topleft, 6 = left, 7 = bottomleft

        #lets setup initial images for player
        self.runB = []
        runB1, null = load_image('warriorB1.gif',-1)
        runB2, null = load_image('warriorB2.gif',-1)
        self.runB.append(runB1)
        self.runB.append(runB2)

        self.runBR = []
        runBR1, null = load_image('warriorBR1.gif',-1)
        runBR2, null = load_image('warriorBR2.gif',-1)
        self.runBR.append(runBR1)
        self.runBR.append(runBR2)

        self.runR = []
        runR1, null = load_image('warriorR1.gif',-1)
        runR2, null = load_image('warriorR2.gif',-1)
        self.runR.append(runR1)
        self.runR.append(runR2)

        self.runTR = []
        runTR1, null = load_image('warriorTR1.gif',-1)
        runTR2, null = load_image('warriorTR2.gif',-1)
        self.runTR.append(runTR1)
        self.runTR.append(runTR2)

        self.runT = []
        runT1, null = load_image('warriorT1.gif',-1)
        runT2, null = load_image('warriorT2.gif',-1)
        self.runT.append(runT1)
        self.runT.append(runT2)

        self.runTL = []
        runTL1 = pygame.transform.flip(runTR1,1,0)
        runTL2 = pygame.transform.flip(runTR2,1,0)
        self.runTL.append(runTL1)
        self.runTL.append(runTL2)

        self.runL = []
        runL1 = pygame.transform.flip(runR1,1,0)
        runL2 = pygame.transform.flip(runR2,1,0)
        self.runL.append(runL1)
        self.runL.append(runL2)

        self.runBL = []
        runBL1 = pygame.transform.flip(runBR1,1,0)
        runBL2 = pygame.transform.flip(runBR2,1,0)
        self.runBL.append(runBL1)
        self.runBL.append(runBL2)
        # all 8 positions have been updated, woop

    def update(self):
        if self.state > 0:
            if self.frameCount == 0:        # frame 0
                if self.direction == 0:
                    self.image = self.runB[0]
                elif self.direction == 1:
                    self.image = self.runBR[0]
                elif self.direction == 2:
                    self.image = self.runR[0]
                elif self.direction == 3:
                    self.image = self.runTR[0]
                elif self.direction == 4:
                    self.image = self.runT[0]
                elif self.direction == 5:
                    self.image = self.runTL[0]
                elif self.direction == 6:
                    self.image = self.runL[0]
                elif self.direction == 7:
                    self.image = self.runBL[0]
            elif self.frameCount == 10:     # frame 1
                if self.direction == 0:
                    self.image = self.runB[1]
                elif self.direction == 1:
                    self.image = self.runBR[1]
                elif self.direction == 2:
                    self.image = self.runR[1]
                elif self.direction == 3:
                    self.image = self.runTR[1]
                elif self.direction == 4:
                    self.image = self.runT[1]
                elif self.direction == 5:
                    self.image = self.runTL[1]
                elif self.direction == 6:
                    self.image = self.runL[1]
                elif self.direction == 7:
                    self.image = self.runBL[1]
            self.frameCount = (self.frameCount + 1) % 20

            #debug
            if self.direction == 0:
                if self.posy >= 440:
                    if self.worldy < self.worldmaxy:
                        self.worldy += self.speed
                else:
                    self.posy += self.speed
            elif self.direction == 1:
                if self.posy >= 440:
                    if self.worldy < self.worldmaxy:
                        self.worldy += self.speed * 0.7
                else:
                    self.posy += self.speed * 0.7
                if self.posx >= 600:
                    if self.worldx < self.worldmaxx:
                        self.worldx += self.speed * 0.7
                else:
                    self.posx += self.speed * 0.7
            elif self.direction == 2:
                if self.posx >= 600:
                    if self.worldx < self.worldmaxx:
                        self.worldx += self.speed
                else:
                    self.posx += self.speed
            elif self.direction == 3:
                if self.posy <= 2:
                    if self.worldy > 2:
                        self.worldy -= self.speed * 0.7
                else:
                    self.posy -= self.speed * 0.7
                if self.posx >= 600:
                    if self.worldx < self.worldmaxx:
                        self.worldx += self.speed * 0.7
                else:
                    self.posx += self.speed * 0.7
            elif self.direction == 4:
                if self.posy <= 2:
                    if self.worldy > 2:
                        self.worldy -= self.speed
                else:
                    self.posy -= self.speed
            elif self.direction == 5:
                if self.posy <= 2:
                    if self.worldy > 2:
                        self.worldy -= self.speed * 0.7
                else:
                    self.posy -= self.speed * 0.7
                if self.posx <= 2:
                    if self.worldx > 2:
                        self.worldx -= self.speed * 0.7
                else:
                    self.posx -= self.speed * 0.7
            elif self.direction == 6:
                if self.posx <= 2:
                    if self.worldx > 2:
                        self.worldx -= self.speed
                else:
                    self.posx -= self.speed
            elif self.direction == 7:
                if self.posy >= 440:
                    if self.worldy < self.worldmaxy:
                        self.worldy += self.speed * 0.7
                else:
                    self.posy += self.speed * 0.7
                if self.posx <= 2:
                    if self.worldx > 2:
                        self.worldx -= self.speed * 0.7
                else:
                    self.posx -= self.speed * 0.7
            self.rect.topleft = (int(self.posx), int(self.posy))

    def moveB(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 0
        elif self.direction == 2:
            self.direction = 1
        elif self.direction == 6:
            self.direction = 7

    def moveR(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 2
        elif self.direction == 0:
            self.direction = 1
        elif self.direction == 4:
            self.direction = 3

    def moveT(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 4
        elif self.direction == 2:
            self.direction = 3
        elif self.direction == 6:
            self.direction = 5

    def moveL(self):
        self.frameCount = 0
        if self.state == 0:
            self.state = 1
            self.direction = 6
        elif self.direction == 4:
            self.direction = 5
        elif self.direction == 0:
            self.direction = 7

    def stopB(self):
        if self.direction == 7:
            self.direction = 6
        elif self.direction == 1:
            self.direction = 2
        else:
            self.state = 0

    def stopR(self):
        if self.direction == 3:
            self.direction = 4
        elif self.direction == 1:
            self.direction = 0
        else:
            self.state = 0

    def stopT(self):
        if self.direction == 3:
            self.direction = 2
        elif self.direction == 5:
            self.direction = 6
        else:
            self.state = 0

    def stopL(self):
        if self.direction == 5:
            self.direction = 4
        elif self.direction == 7:
            self.direction = 0
        else:
            self.state = 0
        
    #define our max X & Y for a world set
    def setMaxX(self, maxX):
        self.worldmaxx = maxX-642

    def setMaxY(self, maxY):
        self.worldmaxy = maxY-482

    def getworldX(self):
        return self.worldx

    def getworldY(self):
        return self.worldy
